BitMagic-C++: bm::bvector< Alloc > Class Template Reference

BitMagic-C++

Data Structures | Public Types | Friends
bm::bvector< Alloc > Class Template Reference
BitMagic Library » bvector<> container

Bitvector Bit-vector container with runtime compression of bits. More...

`#include <bm.h>`

Inheritance diagram for bm::bvector< Alloc >:
[legend]

## Data Structures
struct | allocation_policy
| memory allocation policy More...
class | bulk_insert_iterator
| Output iterator iterator designed to set "ON" bits based on input sequence of integers. More...
class | counted_enumerator
| Constant iterator designed to enumerate "ON" bits counted_enumerator keeps bitcount, ie number of ON bits starting from the position 0 in the bit string up to the currently enumerated bit. More...
class | enumerator
| Constant iterator designed to enumerate "ON" bits. More...
class | insert_iterator
| Output iterator iterator designed to set "ON" bits based on input sequence of integers (bit indeces). More...
class | iterator_base
| Base class for all iterators. More...
class | mem_pool_guard
class | reference
| Class reference implements an object for bit assignment. More...
struct | statistics
| Statistical information about bitset's memory allocation details. More...

## Public Types
enum | optmode { opt_none = 0, opt_free_0 = 1, opt_free_01 = 2, opt_compress = 3 }
| Optimization mode Every next level means additional checks (better compression vs time) More...
typedef Alloc | allocator_type
typedef allocator_type::allocator_pool_type | allocator_pool_type
typedef blocks_manager< Alloc > | blocks_manager_type
typedef blocks_manager_type::block_idx_type | block_idx_type
typedef bm::id_t | size_type
typedef bool | const_reference
typedef rs_index< allocator_type > | blocks_count
typedef rs_index< allocator_type > | rs_index_type

## Public Member Functions
Construction, initialization, assignment
| bvector (strategy strat=BM_BIT, const gap_word_t *glevel_len=bm::gap_len_table< true >::_len, size_type bv_size=bm::id_max, const Alloc &alloc=Alloc())
| Constructs bvector class. More...
| bvector (size_type bv_size, strategy strat=BM_BIT, const gap_word_t *glevel_len=bm::gap_len_table< true >::_len, const Alloc &alloc=Alloc())
| Constructs bvector class. More...
| bvector (const bvector< Alloc > &bvect)
| Copy constructor. More...
| bvector (const bvector< Alloc > &bvect, size_type left, size_type right)
| Copy constructor for range copy [left..right]. More...
| ~bvector () BMNOEXCEPT
void | init ()
| Explicit post-construction initialization. More...
bvector & | operator= (const bvector< Alloc > &bvect)
| Copy assignment operator. More...
| bvector (bvector< Alloc > &&bvect) BMNOEXCEPT
| Move constructor. More...
| bvector (std::initializer_list< size_type > il)
| Brace constructor. More...
bvector & | operator= (bvector< Alloc > &&bvect) BMNOEXCEPT
| Move assignment operator. More...
void | move_from (bvector< Alloc > &bvect) BMNOEXCEPT
| Move bvector content from another bvector. More...
void | swap (bvector< Alloc > &bvect) BMNOEXCEPT
| Exchanges content of bv and this bvector. More...
void | merge (bm::bvector< Alloc > &bvect)
| Merge/move content from another vector. More...
reference | operator[] (size_type n)
bool | operator[] (size_type n) const BMNOEXCEPT
void | operator&= (const bvector< Alloc > &bv)
void | operator^= (const bvector< Alloc > &bv)
void | operator|= (const bvector< Alloc > &bv)
void | operator-= (const bvector< Alloc > &bv)
bool | operator< (const bvector< Alloc > &bv) const
bool | operator<= (const bvector< Alloc > &bv) const
bool | operator> (const bvector< Alloc > &bv) const
bool | operator>= (const bvector< Alloc > &bv) const
bool | operator== (const bvector< Alloc > &bv) const BMNOEXCEPT
bool | operator!= (const bvector< Alloc > &bv) const BMNOEXCEPT
bvector< Alloc > | operator~ () const
Alloc | get_allocator () const
void | set_allocator_pool (allocator_pool_type *pool_ptr) BMNOEXCEPT
| Set allocator pool for local (non-th readed) memory cyclic(lots of alloc-free ops) opertations. More...
allocator_pool_type * | get_allocator_pool () BMNOEXCEPT
| Get curent allocator pool (if set) More...
Bit access/modification methods
bool | set_bit (size_type n, bool val=true)
| Sets bit n. More...
bool | set_bit_and (size_type n, bool val=true)
| Sets bit n using bit AND with the provided value. More...
bool | inc (size_type n)
| Increment the specified element. More...
bool | set_bit_conditional (size_type n, bool val, bool condition)
| Sets bit n only if current value equals the condition. More...
bvector< Alloc > & | set (size_type n, bool val=true)
| Sets bit n if val is true, clears bit n if val is false. More...
bvector< Alloc > & | set ()
| Sets every bit in this bitset to 1. More...
void | set (const size_type *ids, size_type ids_size, bm::sort_order so=bm::BM_UNKNOWN)
| Set list of bits in this bitset to 1. More...
void | keep (const size_type *ids, size_type ids_size, bm::sort_order so=bm::BM_UNKNOWN)
| Keep list of bits in this bitset, others are cleared. More...
void | clear (const size_type *ids, size_type ids_size, bm::sort_order so=bm::BM_UNKNOWN)
| clear list of bits in this bitset More...
void | set_bit_no_check (size_type n)
| Set bit without checking preconditions (size, etc) More...
bool | set_bit_no_check (size_type n, bool val)
| Set specified bit without checking preconditions (size, etc) More...
bvector< Alloc > & | set_range (size_type left, size_type right, bool value=true)
| Sets all bits in the specified closed interval [left,right] Interval must be inside the bvector's size. This method DOES NOT resize vector. More...
void | clear_range (size_type left, size_type right)
| Sets all bits to zero in the specified closed interval [left,right] Interval must be inside the bvector's size. This method DOES NOT resize vector. More...
void | keep_range (size_type left, size_type right)
| Sets all bits to zero outside of the closed interval [left,right] Expected result: 00000...0[left, right]0....0000. More...
void | copy_range (const bvector< Alloc > &bvect, size_type left, size_type right)
| Copy all bits in the specified closed interval [left,right]. More...
bool | clear_bit (size_type n)
| Clears bit n. More...
void | clear_bit_no_check (size_type n)
| Clears bit n without precondiion checks. More...
void | clear (bool free_mem=false)
| Clears every bit in the bitvector. More...
bvector< Alloc > & | reset ()
| Clears every bit in the bitvector. More...
bvector< Alloc > & | flip (size_type n)
| Flips bit n. More...
bvector< Alloc > & | flip ()
| Flips all bits. More...
insert_iterator | inserter ()
Size and capacity
By default bvector is dynamically sized, manual control methods available
size_type | size () const BMNOEXCEPT
| Returns bvector's capacity (number of bits it can store) More...
void | resize (size_type new_size)
| Change size of the bvector. More...
Population counting, ranks, ranges and intervals
size_type | count () const BMNOEXCEPT
| population cout (count of ON bits) More...
block_idx_type | count_blocks (unsigned *arr) const BMNOEXCEPT
| Computes bitcount values for all bvector blocks. More...
size_type | count_range (size_type left, size_type right, const rs_index_type &rs_idx) const BMNOEXCEPT
| Returns count of 1 bits in the given range [left..right] Uses rank-select index to accelerate the search. More...
size_type | count_range (size_type left, size_type right) const BMNOEXCEPT
| Returns count of 1 bits in the given range [left..right]. More...
bool | is_all_one_range (size_type left, size_type right) const BMNOEXCEPT
| Returns true if all bits in the range are 1s (saturated interval) Function uses closed interval [left, right]. More...
bool | any_range (size_type left, size_type right) const BMNOEXCEPT
| Returns true if any bits in the range are 1s (non-empty interval) Function uses closed interval [left, right]. More...
void | build_rs_index (rs_index_type *rs_idx, bvector< Alloc > *bv_blocks=0) const
| compute running total of all blocks in bit vector (rank-select index) More...
size_type | count_to (size_type n, const rs_index_type &rs_idx) const BMNOEXCEPT
| Returns count of 1 bits (population) in [0..right] range. More...
size_type | rank (size_type n, const rs_index_type &rs_idx) const BMNOEXCEPT
| Returns rank of specified bit position (same as count_to()) More...
size_type | rank_corrected (size_type n, const rs_index_type &rs_idx) const BMNOEXCEPT
| Returns rank corrceted by the requested border value (as -1) More...
size_type | count_to_test (size_type n, const rs_index_type &rs_idx) const BMNOEXCEPT
| popcount in [0..right] range if test(right) == true More...
size_type | recalc_count () BMNOEXCEPT
void | forget_count () BMNOEXCEPT
Bit access (read-only)
bool | get_bit (size_type n) const BMNOEXCEPT
| returns true if bit n is set and false is bit n is 0. More...
bool | test (size_type n) const BMNOEXCEPT
| returns true if bit n is set and false is bit n is 0. More...
bit-shift and insert operations
bool | shift_right ()
| Shift right by 1 bit, fill with zero return carry out. More...
bool | shift_left ()
| Shift left by 1 bit, fill with zero return carry out. More...
bool | insert (size_type n, bool value)
| Insert bit into specified position All the vector content after insert position is shifted right. More...
void | erase (size_type n)
| Erase bit in the specified position All the vector content after erase position is shifted left. More...
Check for empty-ness of container
bool | any () const BMNOEXCEPT
| Returns true if any bits in this bitset are set, and otherwise returns false. More...
bool | none () const BMNOEXCEPT
| Returns true if no bits are set, otherwise returns false. More...
Scan and find bits and indexes
bool | find (size_type &pos) const BMNOEXCEPT
| Finds index of first 1 bit. More...
bool | find (size_type from, size_type &pos) const BMNOEXCEPT
| Find index of 1 bit starting from position. More...
size_type | get_first () const BMNOEXCEPT
| find first 1 bit in vector. Function may return 0 and this requires an extra check if bit 0 is actually set or bit-vector is empty More...
size_type | get_next (size_type prev) const BMNOEXCEPT
| Finds the number of the next bit ON. More...
size_type | extract_next (size_type prev)
| Finds the number of the next bit ON and sets it to 0. More...
bool | find_reverse (size_type &pos) const BMNOEXCEPT
| Finds last index of 1 bit. More...
bool | find_range (size_type &first, size_type &last) const BMNOEXCEPT
| Finds dynamic range of bit-vector [first, last]. More...
bool | find_rank (size_type rank, size_type from, size_type &pos) const BMNOEXCEPT
| Find bit-vector position for the specified rank(bitcount) More...
bool | find_rank (size_type rank, size_type from, size_type &pos, const rs_index_type &rs_idx) const BMNOEXCEPT
| Find bit-vector position for the specified rank(bitcount) More...
bool | select (size_type rank, size_type &pos, const rs_index_type &rs_idx) const BMNOEXCEPT
| select bit-vector position for the specified rank(bitcount) More...
Algebra of Sets operations
bm::bvector< Alloc > & | bit_or (const bm::bvector< Alloc > &bv1, const bm::bvector< Alloc > &bv2, typename bm::bvector< Alloc >::optmode opt_mode)
| 3-operand OR : this := bv1 OR bv2 More...
bm::bvector< Alloc > & | bit_xor (const bm::bvector< Alloc > &bv1, const bm::bvector< Alloc > &bv2, typename bm::bvector< Alloc >::optmode opt_mode)
| 3-operand XOR : this := bv1 XOR bv2 More...
bm::bvector< Alloc > & | bit_and (const bm::bvector< Alloc > &bv1, const bm::bvector< Alloc > &bv2, typename bm::bvector< Alloc >::optmode opt_mode)
| 3-operand AND : this := bv1 AND bv2 More...
bm::bvector< Alloc > & | bit_sub (const bm::bvector< Alloc > &bv1, const bm::bvector< Alloc > &bv2, typename bm::bvector< Alloc >::optmode opt_mode)
| 3-operand SUB : this := bv1 MINUS bv2 SUBtraction is also known as AND NOT More...
bm::bvector< Alloc > & | bit_or (const bm::bvector< Alloc > &bv)
| 2 operand logical OR More...
bm::bvector< Alloc > & | bit_and (const bm::bvector< Alloc > &bv, optmode opt_mode=opt_none)
| 2 operand logical AND More...
bm::bvector< Alloc > & | bit_xor (const bm::bvector< Alloc > &bv)
| 2 operand logical XOR More...
bm::bvector< Alloc > & | bit_sub (const bm::bvector< Alloc > &bv)
| 2 operand logical SUB(AND NOT). Also known as MINUS. More...
bvector< Alloc > & | invert ()
| Invert/NEG all bits It should be noted, invert is affected by size() if size is set - it only inverts [0..size-1] bits. More...
void | combine_operation (const bm::bvector< Alloc > &bvect, bm::operation opcode)
| perform a set-algebra operation by operation code More...
void | combine_operation_or (const bm::bvector< Alloc > &bvect)
| perform a set-algebra operation OR More...
void | combine_operation_and (const bm::bvector< Alloc > &bvect, optmode opt_mode)
| perform a set-algebra operation AND More...
void | combine_operation_sub (const bm::bvector< Alloc > &bvect)
| perform a set-algebra operation MINUS (AND NOT) More...
void | combine_operation_xor (const bm::bvector< Alloc > &bvect)
| perform a set-algebra operation XOR More...
Iterator-traversal methods
enumerator | first () const
| Returns enumerator pointing on the first non-zero bit. More...
enumerator | end () const
| Returns enumerator pointing on the next bit after the last. More...
enumerator | get_enumerator (size_type pos) const
| Returns enumerator pointing on specified or the next available bit. More...
Memory management and compression
void | calc_stat (struct bm::bvector< Alloc >::statistics *st) const BMNOEXCEPT
| Calculates bitvector statistics. More...
void | set_new_blocks_strat (strategy strat)
| Sets new blocks allocation strategy. More...
strategy | get_new_blocks_strat () const BMNOEXCEPT
| Returns blocks allocation strategy. More...
void | optimize (bm::word_t *temp_block=0, optmode opt_mode=opt_compress, statistics *stat=0)
| Optimize memory bitvector's memory allocation. More...
void | optimize_gap_size ()
| Optimize sizes of GAP blocks. More...
void | set_gap_levels (const gap_word_t *glevel_len)
| Sets new GAP lengths table. All GAP blocks will be reallocated to match the new scheme. More...
bool | is_init () const BMNOEXCEPT
| Return true if bvector is initialized at all. More...
Comparison
int | compare (const bvector< Alloc > &bvect) const BMNOEXCEPT
| Lexicographical comparison with a bitvector. More...
bool | equal (const bvector< Alloc > &bvect) const BMNOEXCEPT
| Equal comparison with an agr bit-vector. More...
bool | find_first_mismatch (const bvector< Alloc > &bvect, size_type &pos, size_type search_to=bm::id_max) const BMNOEXCEPT
| Find index of first bit different between this and the agr vector. More...

## Friends
class | iterator_base
class | enumerator
template<class BV >
class | aggregator
template<class BV >
class | operation_deserializer

## Open internals
void | combine_operation_with_block (block_idx_type nb, const bm::word_t *arg_blk, bool arg_gap, bm::operation opcode)
const blocks_manager_type & | get_blocks_manager () const BMNOEXCEPT
| get access to memory manager (internal) Use only if you are BitMagic library More...
blocks_manager_type & | get_blocks_manager () BMNOEXCEPT
| get access to memory manager (internal) Use only if you are BitMagic library More...
static void | throw_bad_alloc ()
void | sync_size ()
| Syncronize size if it got extended due to bulk import. More...
void | import (const size_type *ids, size_type ids_size, bm::sort_order sorted_idx)
| Import integers (set bits). More...
void | import_block (const size_type *ids, block_idx_type nblock, size_type start, size_type stop)

## Detailed Description

### template<class Alloc>
class bm::bvector< Alloc >

Bitvector Bit-vector container with runtime compression of bits.

Examples
  bvsetalgebra.cpp, sample14.cpp, sample4.cpp, sample6.cpp, strsvsample05.cpp, and xsample01.cpp.

Definition at line 107 of file bm.h.

## Member Typedef Documentation

## ◆ allocator_pool_type

template<class Alloc >

typedef allocator_type::allocator_pool_type bm::bvector< Alloc >::allocator_pool_type

Definition at line 111 of file bm.h.

## ◆ allocator_type

template<class Alloc >

typedef Alloc bm::bvector< Alloc >::allocator_type

Definition at line 110 of file bm.h.

## ◆ block_idx_type

template<class Alloc >

typedef blocks_manager_type::block_idx_type bm::bvector< Alloc >::block_idx_type

Definition at line 113 of file bm.h.

## ◆ blocks_count

template<class Alloc >

typedef rs_index<allocator_type> bm::bvector< Alloc >::blocks_count

Definition at line 830 of file bm.h.

## ◆ blocks_manager_type

template<class Alloc >

typedef blocks_manager<Alloc> bm::bvector< Alloc >::blocks_manager_type

Definition at line 112 of file bm.h.

## ◆ const_reference

template<class Alloc >

typedef bool bm::bvector< Alloc >::const_reference

Definition at line 230 of file bm.h.

## ◆ rs_index_type

template<class Alloc >

typedef rs_index<allocator_type> bm::bvector< Alloc >::rs_index_type

Definition at line 831 of file bm.h.

## ◆ size_type

template<class Alloc >

typedef bm::id_t bm::bvector< Alloc >::size_type

Definition at line 117 of file bm.h.

## Member Enumeration Documentation

## ◆ optmode

template<class Alloc >

enum bm::bvector::optmode

Optimization mode Every next level means additional checks (better compression vs time)

See also
  optimize

Enumerator
opt_none | no optimization
opt_free_0 | Free unused 0 blocks.
opt_free_01 | Free unused 0 and 1 blocks.
opt_compress | compress blocks when possible (GAP/prefix sum)

Definition at line 129 of file bm.h.

## Constructor & Destructor Documentation

## ◆ bvector() [1/6]

template<class Alloc >

bm::bvector< Alloc >::bvector | ( | strategy | strat = `BM_BIT`,
|  | const gap_word_t * | glevel_len = `bm::gap_len_table<true>::_len`,
|  | size_type | bv_size = `bm::id_max`,
|  | const Alloc & | alloc = `Alloc()`
| ) |  |
| inline

Constructs bvector class.

Parameters

  strat | - operation mode strategy, BM_BIT - default strategy, bvector use plain bitset blocks, (performance oriented strategy). BM_GAP - memory effitent strategy, bvector allocates blocks as array of intervals(gaps) and convert blocks into plain bitsets only when enthropy grows.
  glevel_len | pointer on C-style array keeping GAP block sizes. bm::gap_len_table<true>::_len - default value set (use bm::gap_len_table_min<true>::_len for very sparse vectors) (use bm::gap_len_table_nl<true>::_len non-linear GAP growth)
  bv_size | bvector size (number of bits addressable by bvector), bm::id_max means "no limits" (recommended). bit vector allocates this space dynamically on demand.
  alloc | - alllocator for this instance

See also
  bm::gap_len_table bm::gap_len_table_min set_new_blocks_strat

Definition at line 858 of file bm.h.

## ◆ bvector() [2/6]

template<class Alloc >

bm::bvector< Alloc >::bvector | ( | size_type | bv_size,
|  | strategy | strat = `BM_BIT`,
|  | const gap_word_t * | glevel_len = `bm::gap_len_table<true>::_len`,
|  | const Alloc & | alloc = `Alloc()`
| ) |  |
| inline

Constructs bvector class.

Definition at line 870 of file bm.h.

## ◆ bvector() [3/6]

template<class Alloc >

bm::bvector< Alloc >::bvector | ( | const bvector< Alloc > & | bvect | ) |
| inline

Copy constructor.

Definition at line 882 of file bm.h.

## ◆ bvector() [4/6]

template<class Alloc >

bm::bvector< Alloc >::bvector | ( | const bvector< Alloc > & | bvect,
|  | size_type | left,
|  | size_type | right
| ) |  |
| inline

Copy constructor for range copy [left..right].

See also
  copy_range

Definition at line 893 of file bm.h.

## ◆ ~bvector()

template<class Alloc >

bm::bvector< Alloc >::~bvector | ( |  | ) |
| inline

Definition at line 906 of file bm.h.

## ◆ bvector() [5/6]

template<class Alloc >

bm::bvector< Alloc >::bvector | ( | bvector< Alloc > && | bvect | ) |
| inline

Move constructor.

Definition at line 930 of file bm.h.

## ◆ bvector() [6/6]

template<class Alloc >

bm::bvector< Alloc >::bvector | ( | std::initializer_list< size_type > | il | ) |
| inline

Brace constructor.

Definition at line 940 of file bm.h.

## Member Function Documentation

## ◆ any()

template<typename Alloc >

bool bm::bvector< Alloc >::any

Returns true if any bits in this bitset are set, and otherwise returns false.

Returns
  true if any bit is set

Definition at line 2244 of file bm.h.

Referenced by DNA_FingerprintScanner::Find(), and bm::bvector<>::none().

## ◆ any_range()

template<typename Alloc >

bool bm::bvector< Alloc >::any_range | ( | size_type | left,
|  | size_type | right
| ) |  | const

Returns true if any bits in the range are 1s (non-empty interval) Function uses closed interval [left, right].

Parameters

  left | - index of first bit start checking
  right | - index of last bit

Returns
  true if at least 1 bits is set

See also
  is_all_one_range, count_range

Definition at line 2865 of file bm.h.

Referenced by add_object(), and main().

## ◆ bit_and() [1/2]

template<class Alloc >

bm::bvector<Alloc>& bm::bvector< Alloc >::bit_and | ( | const bm::bvector< Alloc > & | bv,
|  | optmode | opt_mode = `opt_none`
| ) |  |
| inline

2 operand logical AND

Parameters

  bv | - argument vector
  opt_mode | - set an immediate optimization

Definition at line 1704 of file bm.h.

## ◆ bit_and() [2/2]

template<class Alloc >

bm::bvector< Alloc > & bm::bvector< Alloc >::bit_and | ( | const bm::bvector< Alloc > & | bv1,
|  | const bm::bvector< Alloc > & | bv2,
|  | typename bm::bvector< Alloc >::optmode | opt_mode
| ) |  |

3-operand AND : this := bv1 AND bv2

Parameters

  bv1 | - Argument vector 1
  bv2 | - Argument vector 2
  opt_mode | - optimization compression (when it is performed on the fly it is faster than a separate call to optimize()

See also
  optimize, bit_and

Definition at line 5017 of file bm.h.

Referenced by bm::bvector<>::bit_and(), DemoAND(), bm::sparse_vector< unsigned, bm::bvector<> >::filter(), bm::bvector<>::keep(), bm::operator&(), and bm::bvector<>::operator&=().

## ◆ bit_or() [1/2]

template<class Alloc >

bm::bvector<Alloc>& bm::bvector< Alloc >::bit_or | ( | const bm::bvector< Alloc > & | bv | ) |
| inline

2 operand logical OR

Parameters

  bv | - Argument vector.

Definition at line 1693 of file bm.h.

## ◆ bit_or() [2/2]

template<class Alloc >

bm::bvector< Alloc > & bm::bvector< Alloc >::bit_or | ( | const bm::bvector< Alloc > & | bv1,
|  | const bm::bvector< Alloc > & | bv2,
|  | typename bm::bvector< Alloc >::optmode | opt_mode
| ) |  |

3-operand OR : this := bv1 OR bv2

Parameters

  bv1 | - Argument vector 1
  bv2 | - Argument vector 2
  opt_mode | - optimization compression (when it is performed on the fly it is faster than a separate call to optimize()

See also
  optimize, bit_or

Definition at line 4809 of file bm.h.

Referenced by bm::bvector<>::bit_and(), bm::bvector<>::bit_or(), bm::bvector<>::bit_sub(), DemoOR(), bm::dynamic_range_clip_high(), bm::dynamic_range_clip_low(), main(), bm::operator|(), bm::bvector<>::operator|=(), and bm::sparse_vector_find_mismatch().

## ◆ bit_sub() [1/2]

template<class Alloc >

bm::bvector<Alloc>& bm::bvector< Alloc >::bit_sub | ( | const bm::bvector< Alloc > & | bv | ) |
| inline

2 operand logical SUB(AND NOT). Also known as MINUS.

Parameters

  bv | - argument vector.

Definition at line 1725 of file bm.h.

## ◆ bit_sub() [2/2]

template<class Alloc >

bm::bvector< Alloc > & bm::bvector< Alloc >::bit_sub | ( | const bm::bvector< Alloc > & | bv1,
|  | const bm::bvector< Alloc > & | bv2,
|  | typename bm::bvector< Alloc >::optmode | opt_mode
| ) |  |

3-operand SUB : this := bv1 MINUS bv2 SUBtraction is also known as AND NOT

Parameters

  bv1 | - Argument vector 1
  bv2 | - Argument vector 2
  opt_mode | - optimization compression (when it is performed on the fly it is faster than a separate call to optimize()

See also
  optimize, bit_sub

Definition at line 5111 of file bm.h.

Referenced by bm::bvector<>::bit_sub(), bm::bvector<>::clear(), DemoSUB(), bm::operator-(), and bm::bvector<>::operator-=().

## ◆ bit_xor() [1/2]

template<class Alloc >

bm::bvector<Alloc>& bm::bvector< Alloc >::bit_xor | ( | const bm::bvector< Alloc > & | bv | ) |
| inline

2 operand logical XOR

Parameters

  bv | - argument vector.

Definition at line 1715 of file bm.h.

## ◆ bit_xor() [2/2]

template<class Alloc >

bm::bvector< Alloc > & bm::bvector< Alloc >::bit_xor | ( | const bm::bvector< Alloc > & | bv1,
|  | const bm::bvector< Alloc > & | bv2,
|  | typename bm::bvector< Alloc >::optmode | opt_mode
| ) |  |

3-operand XOR : this := bv1 XOR bv2

Parameters

  bv1 | - Argument vector 1
  bv2 | - Argument vector 2
  opt_mode | - optimization compression (when it is performed on the fly it is faster than a separate call to optimize()

See also
  optimize, bit_xor

Definition at line 4906 of file bm.h.

Referenced by bm::bvector<>::bit_xor(), DemoXOR(), bm::operator^(), bm::bvector<>::operator^=(), and bm::sparse_vector_find_mismatch().

## ◆ build_rs_index()

template<typename Alloc >

void bm::bvector< Alloc >::build_rs_index | ( | rs_index_type * | rs_idx,
|  | bvector< Alloc > * | bv_blocks = `0`
| ) |  | const

compute running total of all blocks in bit vector (rank-select index)

Parameters

  rs_idx | - [out] pointer to index / count structure
  bv_blocks | - [out] list of block ids in the vector (internal, optional) Function will fill full array of running totals

See also
  count_to, select, find_rank

Definition at line 2290 of file bm.h.

Referenced by bv_count_range_acc(), bv_count_to_acc(), and bv_count_to_range_acc().

## ◆ calc_stat()

template<typename Alloc >

void bm::bvector< Alloc >::calc_stat | ( | struct bm::bvector< Alloc >::statistics * | st | ) | const

Calculates bitvector statistics.

Parameters

  st | - pointer on statistics structure to be filled in.

Function fills statistics structure containing information about how this vector uses memory and estimation of max. amount of memory bvector needs to serialize itself.

See also
  statistics

Examples
  xsample01.cpp.

Definition at line 3393 of file bm.h.

Referenced by calc_memory_footprint(), convert_bv2bvs(), generate_bvector(), bm::bvector<>::optimize(), bm::bvector<>::optimize_gap_size(), and print_statistics().

## ◆ clear() [1/2]

template<class Alloc >

void bm::bvector< Alloc >::clear | ( | bool | free_mem = `false` | ) |
| inline

Clears every bit in the bitvector.

Parameters

  free_mem | if "true" (default) bvector frees the memory, otherwise sets blocks to 0.

Definition at line 1219 of file bm.h.

## ◆ clear() [2/2]

template<class Alloc >

void bm::bvector< Alloc >::clear | ( | const size_type * | ids,
|  | size_type | ids_size,
|  | bm::sort_order | so = `bm::BM_UNKNOWN`
| ) |  |

clear list of bits in this bitset

This is equivalent of AND NOT (Set Substract), argument set as an array.

Parameters

  ids | - pointer on array of indexes to set
  ids_size | - size of the input (ids)
  so | - sort order (use BM_SORTED for faster load)

See also
  set, keep

Definition at line 3546 of file bm.h.

Referenced by bm::bvector<>::build_rs_index(), bv_count_and(), bm::bvector<>::combine_operation_and(), bm::bvector<>::copy_range(), DemoSUB(), bm::bvector<>::keep(), main(), bm::bvector<>::reset(), speed_test_bv_index(), speed_test_bvs_index(), speed_test_sv_index(), and speed_test_vect_index().

## ◆ clear_bit()

template<class Alloc >

bool bm::bvector< Alloc >::clear_bit | ( | size_type | n | ) |
| inline

Clears bit n.

Parameters

  n | - bit's index to be cleaned.

Returns
  true if bit was cleared

Definition at line 1205 of file bm.h.

## ◆ clear_bit_no_check()

template<class Alloc >

void bm::bvector< Alloc >::clear_bit_no_check | ( | size_type | n | ) |
| inline

Clears bit n without precondiion checks.

Parameters

  n | - bit's index to be cleaned.

Definition at line 1211 of file bm.h.

Referenced by bm::basic_bmatrix< bm::bvector<> >::set_octet(), and bm::sparse_vector< unsigned, bm::bvector<> >::set_value_no_null().

## ◆ clear_range()

template<class Alloc >

void bm::bvector< Alloc >::clear_range | ( | size_type | left,
|  | size_type | right
| ) |  |
| inline

Sets all bits to zero in the specified closed interval [left,right] Interval must be inside the bvector's size. This method DOES NOT resize vector.

Parameters

  left | - interval start
  right | - interval end (closed interval)

See also
  set_range

Definition at line 1174 of file bm.h.

Referenced by main().

## ◆ combine_operation()

template<class Alloc >

void bm::bvector< Alloc >::combine_operation | ( | const bm::bvector< Alloc > & | bvect,
|  | bm::operation | opcode
| ) |  |

perform a set-algebra operation by operation code

Definition at line 5529 of file bm.h.

Referenced by DemoAND(), DemoOR(), DemoSUB(), and DemoXOR().

## ◆ combine_operation_and()

template<class Alloc >

void bm::bvector< Alloc >::combine_operation_and | ( | const bm::bvector< Alloc > & | bvect,
|  | optmode | opt_mode
| ) |  |

perform a set-algebra operation AND

Definition at line 5377 of file bm.h.

Referenced by bm::bvector<>::bit_and().

## ◆ combine_operation_or()

template<class Alloc >

void bm::bvector< Alloc >::combine_operation_or | ( | const bm::bvector< Alloc > & | bvect | ) |

perform a set-algebra operation OR

Definition at line 5206 of file bm.h.

Referenced by bm::bvector<>::bit_or().

## ◆ combine_operation_sub()

template<class Alloc >

void bm::bvector< Alloc >::combine_operation_sub | ( | const bm::bvector< Alloc > & | bvect | ) |

perform a set-algebra operation MINUS (AND NOT)

Definition at line 5465 of file bm.h.

Referenced by bm::bvector<>::bit_sub().

## ◆ combine_operation_with_block()

template<class Alloc >

void bm::bvector< Alloc >::combine_operation_with_block | ( | block_idx_type | nb,
|  | const bm::word_t * | arg_blk,
|  | bool | arg_gap,
|  | bm::operation | opcode
| ) |  |

Definition at line 4792 of file bm.h.

Referenced by bm::bvector<>::combine_operation(), and bm::bvector<>::combine_operation_with_block().

## ◆ combine_operation_xor()

template<class Alloc >

void bm::bvector< Alloc >::combine_operation_xor | ( | const bm::bvector< Alloc > & | bvect | ) |

perform a set-algebra operation XOR

Definition at line 5278 of file bm.h.

Referenced by bm::bvector<>::bit_xor().

## ◆ compare()

template<typename Alloc >

int bm::bvector< Alloc >::compare | ( | const bvector< Alloc > & | bvect | ) | const

Lexicographical comparison with a bitvector.

Function compares current bitvector with the provided argument bit by bit and returns -1 if this bitvector less than the argument, 1 - greater, 0 - equal

Returns
  0 if this == arg, -1 if this < arg, 1 if this > arg

See also
  find_first_mismatch

Examples
  xsample01.cpp.

Definition at line 3159 of file bm.h.

Referenced by convert_bv2bvs(), fingerprint_compare(), main(), bm::bvector<>::operator<(), bm::bvector<>::operator<=(), bm::bvector<>::operator>(), bm::bvector<>::operator>=(), and run_benchmark().

## ◆ copy_range()

template<class Alloc >

void bm::bvector< Alloc >::copy_range | ( | const bvector< Alloc > & | bvect,
|  | size_type | left,
|  | size_type | right
| ) |  |

Copy all bits in the specified closed interval [left,right].

Parameters

  bvect | - source bit-vector
  left | - interval start
  right | - interval end (closed interval)

Definition at line 6653 of file bm.h.

Referenced by main().

## ◆ count()

template<typename Alloc >

bvector< Alloc >::size_type bm::bvector< Alloc >::count

population cout (count of ON bits)

See also
  count_range

Returns
  Total number of bits ON

Examples
  xsample01.cpp.

Definition at line 2194 of file bm.h.

Referenced by bv_count_test(), convert_bv2vect(), main(), pre_heat(), print_bvector(), print_statistics(), bm::bvector<>::recalc_count(), run_benchmark(), and serialize_bvector().

## ◆ count_blocks()

template<typename Alloc >

bvector< Alloc >::block_idx_type bm::bvector< Alloc >::count_blocks | ( | unsigned * | arr | ) | const

Computes bitcount values for all bvector blocks.

Parameters

  arr | - pointer on array of block bit counts

Returns
  Index of the last block counted. This number +1 gives you number of arr elements initialized during the function call.

Definition at line 2405 of file bm.h.

## ◆ count_range() [1/2]

template<typename Alloc >

bvector< Alloc >::size_type bm::bvector< Alloc >::count_range | ( | size_type | left,
|  | size_type | right
| ) |  | const

Returns count of 1 bits in the given range [left..right].

Parameters

  left | - index of first bit start counting from
  right | - index of last bit

Returns
  population count in the diapason

Definition at line 2689 of file bm.h.

## ◆ count_range() [2/2]

template<typename Alloc >

bvector< Alloc >::size_type bm::bvector< Alloc >::count_range | ( | size_type | left,
|  | size_type | right,
|  | const rs_index_type & | rs_idx
| ) |  | const

Returns count of 1 bits in the given range [left..right] Uses rank-select index to accelerate the search.

Parameters

  left | - index of first bit start counting from
  right | - index of last bit
  rs_idx | - block count structure to accelerate search

See also
  build_rs_index

Returns
  population count in the diapason

Definition at line 2959 of file bm.h.

Referenced by bv_count_range(), and bv_count_range_acc().

## ◆ count_to()

template<typename Alloc >

bvector< Alloc >::size_type bm::bvector< Alloc >::count_to | ( | size_type | n,
|  | const rs_index_type & | rs_idx
| ) |  | const

Returns count of 1 bits (population) in [0..right] range.

This operation is also known as rank of bit N.

Parameters

  n | - index of bit to rank
  rs_idx | - rank-select to accelerate search should be prepared using build_rs_index

Returns
  population count in the range [0..n]

See also
  build_rs_index
  count_to_test, select, rank, rank_corrected

Definition at line 2533 of file bm.h.

Referenced by bv_count_to_acc(), bv_count_to_range_acc(), bm::bvector<>::count_range(), and bm::bvector<>::rank().

## ◆ count_to_test()

template<typename Alloc >

bvector< Alloc >::size_type bm::bvector< Alloc >::count_to_test | ( | size_type | n,
|  | const rs_index_type & | rs_idx
| ) |  | const

popcount in [0..right] range if test(right) == true

This is conditional rank operation, which is faster than test() plus count_to()

Parameters

  n | - index of bit to test and rank
  rs_idx | - rank-select index (block count structure to accelerate search) should be prepared using build_rs_index()

Returns
  population count in the diapason or 0 if right bit test failed

See also
  build_rs_index
  count_to

Definition at line 2587 of file bm.h.

## ◆ end()

template<class Alloc >

bvector::enumerator bm::bvector< Alloc >::end | ( |  | ) | const
| inline

Returns enumerator pointing on the next bit after the last.

Definition at line 1776 of file bm.h.

Referenced by combine_or_test(), main(), speed_test_sv_index(), and speed_test_vect_index().

## ◆ equal()

template<class Alloc >

bool bm::bvector< Alloc >::equal | ( | const bvector< Alloc > & | bvect | ) | const
| inline

Equal comparison with an agr bit-vector.

Returns
  true if vectors are identical

Definition at line 1883 of file bm.h.

Referenced by main(), bm::bvector<>::operator!=(), and bm::bvector<>::operator==().

## ◆ erase()

template<class Alloc >

void bm::bvector< Alloc >::erase | ( | size_type | n | ) |

Erase bit in the specified position All the vector content after erase position is shifted left.

Parameters

  n | - index of the bit to insert

Definition at line 4555 of file bm.h.

Referenced by bm::bvector<>::shift_left().

## ◆ extract_next()

template<class Alloc >

bm::id_t bm::bvector< Alloc >::extract_next | ( | size_type | prev | ) |
| inline

Finds the number of the next bit ON and sets it to 0.

Parameters

  prev | - Index of the previously found bit.

Returns
  Index of the next bit which is ON or 0 if not found.

See also
  get_first, get_next, find_reverse

Definition at line 1550 of file bm.h.

Referenced by main().

## ◆ find() [1/2]

template<class Alloc >

bool bm::bvector< Alloc >::find | ( | size_type & | pos | ) | const

Finds index of first 1 bit.

Parameters

  pos | - [out] index of the found 1 bit

Returns
  true if search returned result

See also
  get_first, get_next, extract_next, find_reverse, find_first_mismatch

Definition at line 4035 of file bm.h.

Referenced by bm::bvector<>::find(), bm::bvector<>::find_first_mismatch(), bm::bvector<>::find_range(), and main().

## ◆ find() [2/2]

template<class Alloc >

bool bm::bvector< Alloc >::find | ( | size_type | from,
|  | size_type & | pos
| ) |  | const

Find index of 1 bit starting from position.

Parameters

  from | - position to start search from
  pos | - [out] index of the found 1 bit

Returns
  true if search returned result

See also
  get_first, get_next, extract_next, find_reverse, find_first_mismatch

Definition at line 3963 of file bm.h.

## ◆ find_first_mismatch()

template<typename Alloc >

bool bm::bvector< Alloc >::find_first_mismatch | ( | const bvector< Alloc > & | bvect,
|  | size_type & | pos,
|  | size_type | search_to = `bm::id_max`
| ) |  | const

Find index of first bit different between this and the agr vector.

Parameters

  bvect | - argumnet vector to compare with
  pos | - [out] position of the first difference
  search_to | - search limiter [0..to] to avoid overscan (default: unlimited to the vectors end)

Returns
  true if didfference found, false - both vectors are equivalent

See also
  compare

Definition at line 3277 of file bm.h.

Referenced by bm::bvector<>::equal(), and main().

## ◆ find_range()

template<class Alloc >

bool bm::bvector< Alloc >::find_range | ( | size_type & | first,
|  | size_type & | last
| ) |  | const

Finds dynamic range of bit-vector [first, last].

Parameters

  first | - index of the first found 1 bit
  last | - index of the last found 1 bit

Returns
  true if search returned result

See also
  get_first, get_next, extract_next, find, find_reverse

Definition at line 4081 of file bm.h.

Referenced by main().

## ◆ find_rank() [1/2]

template<class Alloc >

bool bm::bvector< Alloc >::find_rank | ( | size_type | rank,
|  | size_type | from,
|  | size_type & | pos
| ) |  | const

Find bit-vector position for the specified rank(bitcount)

Rank based search, counts number of 1s from specified position until finds the ranked position relative to start from position. In other words: range population count between from and pos == rank.

Parameters

  rank | - rank to find (bitcount)
  from | - start positioon for rank search
  pos | - position with speciefied rank (relative to from position)

Returns
  true if requested rank was found

Definition at line 4101 of file bm.h.

## ◆ find_rank() [2/2]

template<class Alloc >

bool bm::bvector< Alloc >::find_rank | ( | size_type | rank,
|  | size_type | from,
|  | size_type & | pos,
|  | const rs_index_type & | rs_idx
| ) |  | const

Find bit-vector position for the specified rank(bitcount)

Rank based search, counts number of 1s from specified position until finds the ranked position relative to start from position. In other words: range population count between from and pos == rank.

Parameters

  rank | - rank to find (bitcount)
  from | - start positioon for rank search
  pos | - position with speciefied rank (relative to from position)
  rs_idx | - rank-select index to accelarate search (should be prepared using build_rs_index)

See also
  build_rs_index, select

Returns
  true if requested rank was found

Definition at line 4154 of file bm.h.

## ◆ find_reverse()

template<class Alloc >

bool bm::bvector< Alloc >::find_reverse | ( | size_type & | pos | ) | const

Finds last index of 1 bit.

Parameters

  pos | - index of the last found 1 bit

Returns
  true if search returned result

See also
  get_first, get_next, extract_next, find, find_first_mismatch

Definition at line 3978 of file bm.h.

Referenced by bm::bvector<>::build_rs_index(), bm::bvector<>::clear(), bm::bvector<>::find_range(), bm::bvector<>::keep(), main(), and bm::bvector<>::sync_size().

## ◆ first()

template<class Alloc >

enumerator bm::bvector< Alloc >::first | ( |  | ) | const
| inline

Returns enumerator pointing on the first non-zero bit.

Examples
  xsample01.cpp.

Definition at line 1770 of file bm.h.

Referenced by bv2delta(), bv_counted_enumerator(), convert_bv2sv(), convert_bv2vect(), generate_random_subset(), main(), print_bvector(), print_sorted(), speed_test_bv_index(), speed_test_bvs_index(), speed_test_sv_index(), speed_test_vect_index(), and DNA_FingerprintScanner::TranslateResults().

## ◆ flip() [1/2]

template<class Alloc >

bvector<Alloc>& bm::bvector< Alloc >::flip | ( |  | ) |
| inline

Flips all bits.

Returns
  *this

See also
  invert

Definition at line 1238 of file bm.h.

## ◆ flip() [2/2]

template<class Alloc >

bvector<Alloc>& bm::bvector< Alloc >::flip | ( | size_type | n | ) |
| inline

Flips bit n.

Returns
  *this

Definition at line 1231 of file bm.h.

## ◆ forget_count()

template<class Alloc >

void bm::bvector< Alloc >::forget_count | ( |  | ) |
| inline

Disables count cache. (deprecated).

Definition at line 1420 of file bm.h.

## ◆ get_allocator()

template<class Alloc >

Alloc bm::bvector< Alloc >::get_allocator | ( |  | ) | const
| inline

Definition at line 1016 of file bm.h.

## ◆ get_allocator_pool()

template<class Alloc >

allocator_pool_type* bm::bvector< Alloc >::get_allocator_pool | ( |  | ) |
| inline

Get curent allocator pool (if set)

Returns
  pointer to the current pool or NULL

Definition at line 1027 of file bm.h.

## ◆ get_bit()

template<typename Alloc >

bool bm::bvector< Alloc >::get_bit | ( | size_type | n | ) | const

returns true if bit n is set and false is bit n is 0.

Parameters

  n | - Index of the bit to check.

Returns
  Bit value (1 or 0)

Definition at line 3037 of file bm.h.

Referenced by bm::bvector<>::operator[](), and bm::bvector<>::test().

## ◆ get_blocks_manager() [1/2]

template<class Alloc >

blocks_manager_type& bm::bvector< Alloc >::get_blocks_manager | ( |  | ) |
| inline

get access to memory manager (internal) Use only if you are BitMagic library

Definition at line 1932 of file bm.h.

## ◆ get_blocks_manager() [2/2]

template<class Alloc >

const blocks_manager_type& bm::bvector< Alloc >::get_blocks_manager | ( |  | ) | const
| inline

get access to memory manager (internal) Use only if you are BitMagic library

Definition at line 1924 of file bm.h.

Referenced by bm::bvector<>::bit_and(), bm::bvector<>::bit_or(), bm::bvector<>::bit_sub(), bm::bvector<>::bit_xor(), and bm::basic_bmatrix< bm::bvector<> >::optimize_block().

## ◆ get_enumerator()

template<class Alloc >

enumerator bm::bvector< Alloc >::get_enumerator | ( | size_type | pos | ) | const
| inline

Returns enumerator pointing on specified or the next available bit.

Definition at line 1782 of file bm.h.

Referenced by bm::bvector<>::first().

## ◆ get_first()

template<class Alloc >

bm::id_t bm::bvector< Alloc >::get_first | ( |  | ) | const
| inline

find first 1 bit in vector. Function may return 0 and this requires an extra check if bit 0 is actually set or bit-vector is empty

Returns
  Index of the first 1 bit, may return 0

See also
  get_next, find, extract_next, find_reverse

Definition at line 1531 of file bm.h.

Referenced by bm::bvector_mini< A >::compare(), and print_bvector().

## ◆ get_new_blocks_strat()

template<class Alloc >

strategy bm::bvector< Alloc >::get_new_blocks_strat | ( |  | ) | const
| inline

Returns blocks allocation strategy.

Returns
  - Strategy code 0 - bitblocks allocation only. 1 - Blocks mutation mode (adaptive algorithm)

See also
  set_new_blocks_strat

Definition at line 1818 of file bm.h.

Referenced by bm::bvector<>::inc(), and bm::bvector<>::set_bit_no_check().

## ◆ get_next()

template<class Alloc >

bm::id_t bm::bvector< Alloc >::get_next | ( | size_type | prev | ) | const
| inline

Finds the number of the next bit ON.

Parameters

  prev | - Index of the previously found bit.

Returns
  Index of the next bit which is ON or 0 if not found.

See also
  get_first, find, extract_next, find_reverse

Definition at line 1540 of file bm.h.

Referenced by bm::bvector_mini< A >::compare(), and print_bvector().

## ◆ import()

template<class Alloc >

void bm::bvector< Alloc >::import | ( | const size_type * | ids,
|  | size_type | ids_size,
|  | bm::sort_order | sorted_idx
| ) |  |
| protected

Import integers (set bits).

(Fast, no checks).

Definition at line 3634 of file bm.h.

Referenced by bm::bvector<>::clear(), bm::bvector< Alloc >::bulk_insert_iterator::flush(), bm::bvector<>::keep(), and bm::bvector< Alloc >::bulk_insert_iterator::operator=().

## ◆ import_block()

template<class Alloc >

void bm::bvector< Alloc >::import_block | ( | const size_type * | ids,
|  | block_idx_type | nblock,
|  | size_type | start,
|  | size_type | stop
| ) |  |
| protected

Definition at line 3685 of file bm.h.

Referenced by bm::bvector<>::import().

## ◆ inc()

template<class Alloc >

bool bm::bvector< Alloc >::inc | ( | size_type | n | ) |

Increment the specified element.

Bit increment rules: 0 + 1 = 1 (no carry over) 1 + 1 = 0 (with carry over returned)

Parameters

  n | - index of the bit to be set

Returns
  TRUE if carry over created (1+1)

Definition at line 3800 of file bm.h.

Referenced by bm::bvector<>::flip(), and bm::sparse_vector< unsigned, bm::bvector<> >::inc().

## ◆ init()

template<typename Alloc >

void bm::bvector< Alloc >::init

Explicit post-construction initialization.

Definition at line 2123 of file bm.h.

Referenced by bm::bvector<>::build_rs_index(), bm::bvector< Alloc >::bulk_insert_iterator::bulk_insert_iterator(), bv_set_bit_no_check_test(), bm::bvector<>::bvector(), bm::bvector< Alloc >::insert_iterator::insert_iterator(), bm::basic_bmatrix< bm::bvector<> >::insert_octet(), load_snp_report(), main(), run_benchmark(), bm::basic_bmatrix< bm::bvector<> >::set_octet(), and vector_search().

## ◆ insert()

template<class Alloc >

bool bm::bvector< Alloc >::insert | ( | size_type | n,
|  | bool | value
| ) |  |

Insert bit into specified position All the vector content after insert position is shifted right.

Parameters

  n | - index of the bit to insert
  value | - insert value

Returns
  Carry over bit value (1 or 0)

Definition at line 4378 of file bm.h.

Referenced by bm::basic_bmatrix< bm::bvector<> >::insert_octet(), bm::sparse_vector< unsigned, bm::bvector<> >::insert_value_no_null(), and bm::bvector<>::shift_right().

## ◆ inserter()

template<class Alloc >

insert_iterator bm::bvector< Alloc >::inserter | ( |  | ) |
| inline

Function erturns insert iterator for this bitvector

Definition at line 1245 of file bm.h.

Referenced by main().

## ◆ invert()

template<typename Alloc >

bvector< Alloc > & bm::bvector< Alloc >::invert

Invert/NEG all bits It should be noted, invert is affected by size() if size is set - it only inverts [0..size-1] bits.

Definition at line 2987 of file bm.h.

Referenced by DemoINV(), bm::bvector<>::flip(), bm::bvector<>::operator~(), and bm::sparse_vector_find_mismatch().

## ◆ is_all_one_range()

template<typename Alloc >

bool bm::bvector< Alloc >::is_all_one_range | ( | size_type | left,
|  | size_type | right
| ) |  | const

Returns true if all bits in the range are 1s (saturated interval) Function uses closed interval [left, right].

Parameters

  left | - index of first bit start checking
  right | - index of last bit

Returns
  true if all bits are 1, false otherwise

See also
  any_range, count_range

Definition at line 2781 of file bm.h.

Referenced by main().

## ◆ is_init()

template<class Alloc >

bool bm::bvector< Alloc >::is_init | ( |  | ) | const
| inline

Return true if bvector is initialized at all.

Definition at line 1858 of file bm.h.

## ◆ keep()

template<class Alloc >

void bm::bvector< Alloc >::keep | ( | const size_type * | ids,
|  | size_type | ids_size,
|  | bm::sort_order | so = `bm::BM_UNKNOWN`
| ) |  |

Keep list of bits in this bitset, others are cleared.

This is equivalent of AND (Set Intersect), argument set as an array.

Parameters

  ids | - pointer on array of indexes to set
  ids_size | - size of the input (ids)
  so | - sort order (use BM_SORTED for faster load)

See also
  set, clear

Definition at line 3518 of file bm.h.

Referenced by DemoAND().

## ◆ keep_range()

template<class Alloc >

void bm::bvector< Alloc >::keep_range | ( | size_type | left,
|  | size_type | right
| ) |  |

Sets all bits to zero outside of the closed interval [left,right] Expected result: 00000...0[left, right]0....0000.

Parameters

  left | - interval start
  right | - interval end (closed interval)

See also
  set_range

Definition at line 2145 of file bm.h.

Referenced by main().

## ◆ merge()

template<class Alloc >

void bm::bvector< Alloc >::merge | ( | bm::bvector< Alloc > & | bvect | ) |

Merge/move content from another vector.

Merge performs a logical OR operation, but the source vector is not immutable. Source content gets destroyed (memory moved) to create a union of two vectors. Merge operation can be more efficient than OR if argument is a temporary vector.

Parameters

  bvect | - [in, out] - source vector (NOT immutable)

Definition at line 4724 of file bm.h.

Referenced by DemoOR(), and bm::sparse_vector< unsigned, bm::bvector<> >::merge().

## ◆ move_from()

template<typename Alloc >

void bm::bvector< Alloc >::move_from | ( | bvector< Alloc > & | bvect | ) |

Move bvector content from another bvector.

Definition at line 2132 of file bm.h.

Referenced by bm::bvector<>::merge(), and bm::bvector<>::operator=().

## ◆ none()

template<class Alloc >

bool bm::bvector< Alloc >::none | ( |  | ) | const
| inline

Returns true if no bits are set, otherwise returns false.

Definition at line 1494 of file bm.h.

## ◆ operator!=()

template<class Alloc >

bool bm::bvector< Alloc >::operator!= | ( | const bvector< Alloc > & | bv | ) | const
| inline

Definition at line 1012 of file bm.h.

## ◆ operator&=()

template<class Alloc >

void bm::bvector< Alloc >::operator&= | ( | const bvector< Alloc > & | bv | ) |
| inline

Definition at line 1002 of file bm.h.

## ◆ operator-=()

template<class Alloc >

void bm::bvector< Alloc >::operator-= | ( | const bvector< Alloc > & | bv | ) |
| inline

Definition at line 1005 of file bm.h.

## ◆ operator<()

template<class Alloc >

bool bm::bvector< Alloc >::operator< | ( | const bvector< Alloc > & | bv | ) | const
| inline

Definition at line 1007 of file bm.h.

## ◆ operator<=()

template<class Alloc >

bool bm::bvector< Alloc >::operator<= | ( | const bvector< Alloc > & | bv | ) | const
| inline

Definition at line 1008 of file bm.h.

## ◆ operator=() [1/2]

template<class Alloc >

bvector& bm::bvector< Alloc >::operator= | ( | bvector< Alloc > && | bvect | ) |
| inline

Move assignment operator.

Definition at line 957 of file bm.h.

## ◆ operator=() [2/2]

template<class Alloc >

bvector& bm::bvector< Alloc >::operator= | ( | const bvector< Alloc > & | bvect | ) |
| inline

Copy assignment operator.

Definition at line 915 of file bm.h.

## ◆ operator==()

template<class Alloc >

bool bm::bvector< Alloc >::operator== | ( | const bvector< Alloc > & | bv | ) | const
| inline

Definition at line 1011 of file bm.h.

## ◆ operator>()

template<class Alloc >

bool bm::bvector< Alloc >::operator> | ( | const bvector< Alloc > & | bv | ) | const
| inline

Definition at line 1009 of file bm.h.

## ◆ operator>=()

template<class Alloc >

bool bm::bvector< Alloc >::operator>= | ( | const bvector< Alloc > & | bv | ) | const
| inline

Definition at line 1010 of file bm.h.

## ◆ operator[]() [1/2]

template<class Alloc >

reference bm::bvector< Alloc >::operator[] | ( | size_type | n | ) |
| inline

Definition at line 986 of file bm.h.

## ◆ operator[]() [2/2]

template<class Alloc >

bool bm::bvector< Alloc >::operator[] | ( | size_type | n | ) | const
| inline

Definition at line 996 of file bm.h.

## ◆ operator^=()

template<class Alloc >

void bm::bvector< Alloc >::operator^= | ( | const bvector< Alloc > & | bv | ) |
| inline

Definition at line 1003 of file bm.h.

## ◆ operator|=()

template<class Alloc >

void bm::bvector< Alloc >::operator|= | ( | const bvector< Alloc > & | bv | ) |
| inline

Definition at line 1004 of file bm.h.

## ◆ operator~()

template<class Alloc >

bvector<Alloc> bm::bvector< Alloc >::operator~ | ( |  | ) | const
| inline

Definition at line 1014 of file bm.h.

## ◆ optimize()

template<typename Alloc >

void bm::bvector< Alloc >::optimize | ( | bm::word_t * | temp_block = `0`,
|  | optmode | opt_mode = `opt_compress`,
|  | statistics * | stat = `0`
| ) |  |

Optimize memory bitvector's memory allocation.

Function analyze all blocks in the bitvector, compresses blocks with a regular structure, frees some memory. This function is recommended after a bulk modification of the bitvector using set_bit, clear_bit or logical operations.

Optionally function can calculate vector post optimization statistics

See also
  optmode, optimize_gap_size

Examples
  xsample01.cpp.

Definition at line 3071 of file bm.h.

Referenced by generate_bvector(), main(), make_BLOB(), bm::basic_bmatrix< bm::bvector<> >::optimize(), serialize_bvector(), speed_test_bv_index(), speed_test_bvs_index(), speed_test_sv_index(), and speed_test_vect_index().

## ◆ optimize_gap_size()

template<typename Alloc >

void bm::bvector< Alloc >::optimize_gap_size

Optimize sizes of GAP blocks.

This method runs an analysis to find optimal GAP levels for the specific vector. Current GAP compression algorithm uses several fixed GAP sizes. By default bvector uses some reasonable preset.

Definition at line 3117 of file bm.h.

Referenced by bm::sparse_vector< unsigned, bm::bvector<> >::optimize_gap_size().

## ◆ rank()

template<class Alloc >

size_type bm::bvector< Alloc >::rank | ( | size_type | n,
|  | const rs_index_type & | rs_idx
| ) |  | const
| inline

Returns rank of specified bit position (same as count_to())

Parameters

  n | - index of bit to rank
  rs_idx | - rank-select index

Returns
  population count in the range [0..n]

See also
  build_rs_index
  count_to_test, select, rank, rank_corrected

Definition at line 1371 of file bm.h.

Referenced by bm::bvector< Alloc >::enumerator::skip(), and bm::bvector< Alloc >::enumerator::skip_to_rank().

## ◆ rank_corrected()

template<typename Alloc >

bvector< Alloc >::size_type bm::bvector< Alloc >::rank_corrected | ( | size_type | n,
|  | const rs_index_type & | rs_idx
| ) |  | const

Returns rank corrceted by the requested border value (as -1)

This is rank function (bit-count) minus value of bit 'n' if bit-n is true function returns rank()-1 if false returns rank() faster than rank() + test().

Parameters

  n | - index of bit to rank
  rs_idx | - rank-select index

Returns
  population count in the range [0..n] corrected as -1 by the value of n

See also
  build_rs_index
  count_to_test, select, rank

Definition at line 2644 of file bm.h.

## ◆ recalc_count()

template<class Alloc >

size_type bm::bvector< Alloc >::recalc_count | ( |  | ) |
| inline

Recalculate bitcount (deprecated)

Definition at line 1415 of file bm.h.

## ◆ reset()

template<class Alloc >

bvector<Alloc>& bm::bvector< Alloc >::reset | ( |  | ) |
| inline

Clears every bit in the bitvector.

Returns
  *this;

Definition at line 1225 of file bm.h.

Referenced by bv_set_bit_test(), and generate_test_set().

## ◆ resize()

template<typename Alloc >

void bm::bvector< Alloc >::resize | ( | size_type | new_size | ) |

Change size of the bvector.

Parameters

  new_size | - new size in bits

Examples
  xsample01.cpp.

Definition at line 2256 of file bm.h.

Referenced by bm::bvector<>::clear(), convert_bv2sv(), DemoAND(), DemoINV(), DemoOR(), DemoSUB(), DemoXOR(), bm::bvector<>::keep(), bm::bvector< Alloc >::insert_iterator::operator=(), bm::bvector<>::operator=(), bm::bvector<>::operator[](), pick_benchmark_set(), bm::bvector<>::set_bit(), bm::bvector<>::set_bit_conditional(), bm::bvector<>::set_range(), bm::sparse_vector_find_first_mismatch(), bm::sparse_vector_find_mismatch(), and bm::bvector<>::sync_size().

## ◆ select()

template<class Alloc >

bool bm::bvector< Alloc >::select | ( | size_type | rank,
|  | size_type & | pos,
|  | const rs_index_type & | rs_idx
| ) |  | const

select bit-vector position for the specified rank(bitcount)

Rank based search, counts number of 1s from specified position until finds the ranked position relative to start from position. Uses In other words: range population count between from and pos == rank.

Parameters

  rank | - rank to find (bitcount)
  pos | - position with speciefied rank (relative to from position) [out]
  rs_idx | - block count structure to accelerate rank search

See also
  running_count_blocks, find_rank

Returns
  true if requested rank was found

Definition at line 4225 of file bm.h.

Referenced by main().

## ◆ set() [1/3]

template<class Alloc >

bvector< Alloc > & bm::bvector< Alloc >::set

Sets every bit in this bitset to 1.

Returns
  *this

Definition at line 3572 of file bm.h.

Referenced by bm::bvector<>::insert().

## ◆ set() [2/3]

template<class Alloc >

void bm::bvector< Alloc >::set | ( | const size_type * | ids,
|  | size_type | ids_size,
|  | bm::sort_order | so = `bm::BM_UNKNOWN`
| ) |  |

Set list of bits in this bitset to 1.

Method implements optimized bulk setting of multiple bits at once. The best results are achieved when the imput comes sorted. This is equivalent of OR (Set Union), argument set as an array.

Parameters

  ids | - pointer on array of indexes to set
  ids_size | - size of the input (ids)
  so | - sort order (use BM_SORTED for faster load)

See also
  keep, clear

Definition at line 3503 of file bm.h.

## ◆ set() [3/3]

template<class Alloc >

bvector< Alloc > & bm::bvector< Alloc >::set | ( | size_type | n,
|  | bool | val = `true`
| ) |  |

Sets bit n if val is true, clears bit n if val is false.

Parameters

  n | - index of the bit to be set
  val | - new bit value

Returns
  *this

Definition at line 3581 of file bm.h.

Referenced by bm::bvector<>::build_rs_index(), bvector_bulk_set_test(), bm::sparse_vector< unsigned, bm::bvector<> >::clear(), DemoOR(), fill_bvector(), generate_bvector(), bm::sparse_vector< unsigned, bm::bvector<> >::import(), main(), pick_benchmark_set(), and run_benchmark().

## ◆ set_allocator_pool()

template<class Alloc >

void bm::bvector< Alloc >::set_allocator_pool | ( | allocator_pool_type * | pool_ptr | ) |
| inline

Set allocator pool for local (non-th readed) memory cyclic(lots of alloc-free ops) opertations.

Definition at line 1022 of file bm.h.

## ◆ set_bit()

template<class Alloc >

bool bm::bvector< Alloc >::set_bit | ( | size_type | n,
|  | bool | val = `true`
| ) |  |

Sets bit n.

Parameters

  n | - index of the bit to be set.
  val | - new bit value

Returns
  TRUE if bit was changed

Examples
  xsample01.cpp.

Definition at line 3617 of file bm.h.

Referenced by bv_set_bit_test(), bm::bvector<>::clear_bit(), fill_bvector(), generate_random_vector(), and bm::bvector<>::set().

## ◆ set_bit_and()

template<class Alloc >

bool bm::bvector< Alloc >::set_bit_and | ( | size_type | n,
|  | bool | val = `true`
| ) |  |

Sets bit n using bit AND with the provided value.

Parameters

  n | - index of the bit to be set.
  val | - new bit value

Returns
  TRUE if bit was changed

Definition at line 3604 of file bm.h.

## ◆ set_bit_conditional()

template<class Alloc >

bool bm::bvector< Alloc >::set_bit_conditional | ( | size_type | n,
|  | bool | val,
|  | bool | condition
| ) |  |

Sets bit n only if current value equals the condition.

Parameters

  n | - index of the bit to be set.
  val | - new bit value
  condition | - expected current value

Returns
  TRUE if bit was changed

Definition at line 3590 of file bm.h.

## ◆ set_bit_no_check() [1/2]

template<class Alloc >

void bm::bvector< Alloc >::set_bit_no_check | ( | size_type | n | ) |

Set bit without checking preconditions (size, etc)

Fast set bit method, without safety net. Make sure you call bvector<>::init() before setting bits with this function.

Parameters

  n | - bit number

Definition at line 3468 of file bm.h.

Referenced by bv_set_bit_no_check_test(), bm::bvector<>::bvector(), bm::bvector<>::clear_bit_no_check(), bm::bvector<>::erase(), bm::bvector<>::import(), bm::sparse_vector< unsigned, bm::bvector<> >::inc(), bm::bvector<>::insert(), bm::basic_bmatrix< bm::bvector<> >::insert_octet(), bm::bvector<>::invert(), load_snp_report(), main(), bm::bvector< Alloc >::insert_iterator::operator=(), run_benchmark(), bm::bvector<>::set_bit(), bm::basic_bmatrix< bm::bvector<> >::set_octet(), bm::sparse_vector< unsigned, bm::bvector<> >::set_value(), bm::sparse_vector< unsigned, bm::bvector<> >::set_value_no_null(), and vector_search().

## ◆ set_bit_no_check() [2/2]

template<class Alloc >

bool bm::bvector< Alloc >::set_bit_no_check | ( | size_type | n,
|  | bool | val
| ) |  |

Set specified bit without checking preconditions (size, etc)

Definition at line 3716 of file bm.h.

## ◆ set_gap_levels()

template<typename Alloc >

void bm::bvector< Alloc >::set_gap_levels | ( | const gap_word_t * | glevel_len | ) |

Sets new GAP lengths table. All GAP blocks will be reallocated to match the new scheme.

Parameters

  glevel_len | - pointer on C-style array keeping GAP block sizes.

Definition at line 3143 of file bm.h.

Referenced by bm::bvector<>::optimize_gap_size().

## ◆ set_new_blocks_strat()

template<class Alloc >

void bm::bvector< Alloc >::set_new_blocks_strat | ( | strategy | strat | ) |
| inline

Sets new blocks allocation strategy.

Parameters

  strat | - Strategy code 0 - bitblocks allocation only. 1 - Blocks mutation mode (adaptive algorithm)

Definition at line 1810 of file bm.h.

Referenced by main().

## ◆ set_range()

template<typename Alloc >

bvector< Alloc > & bm::bvector< Alloc >::set_range | ( | size_type | left,
|  | size_type | right,
|  | bool | value = `true`
| ) |  |

Sets all bits in the specified closed interval [left,right] Interval must be inside the bvector's size. This method DOES NOT resize vector.

Parameters

  left | - interval start
  right | - interval end (closed interval)
  value | - value to set interval in

Returns
  *this

See also
  clear_range

Examples
  strsvsample05.cpp.

Definition at line 2158 of file bm.h.

Referenced by add_object(), bv_count_and(), bm::bvector<>::clear_range(), bm::bvector<>::combine_operation(), generate_bvector(), bm::sparse_vector< unsigned, bm::bvector<> >::import(), bm::sparse_vector< unsigned, bm::bvector<> >::join(), main(), bm::sparse_vector< unsigned, bm::bvector<> >::merge(), bm::bvector<>::resize(), bm::bvector<>::set(), and bm::bvector<>::set_range().

## ◆ shift_left()

template<class Alloc >

bool bm::bvector< Alloc >::shift_left

Shift left by 1 bit, fill with zero return carry out.

Returns
  Carry over bit value (1 or 0)

Definition at line 4368 of file bm.h.

## ◆ shift_right()

template<class Alloc >

bool bm::bvector< Alloc >::shift_right

Shift right by 1 bit, fill with zero return carry out.

Returns
  Carry over bit value (1 or 0)

Definition at line 4360 of file bm.h.

Referenced by DNA_FingerprintScanner::Find().

## ◆ size()

template<class Alloc >

size_type bm::bvector< Alloc >::size | ( |  | ) | const
| inline

Returns bvector's capacity (number of bits it can store)

return current size of the vector (bits)

Definition at line 1258 of file bm.h.

Referenced by bm::bvector< Alloc >::insert_iterator::operator=(), bm::bvector<>::operator=(), print_bvector(), run_benchmark(), and bm::sparse_vector_find_mismatch().

## ◆ swap()

template<typename Alloc >

void bm::bvector< Alloc >::swap | ( | bvector< Alloc > & | bvect | ) |

Exchanges content of bv and this bvector.

Definition at line 3381 of file bm.h.

Referenced by main().

## ◆ sync_size()

template<typename Alloc >

void bm::bvector< Alloc >::sync_size
| protected

Syncronize size if it got extended due to bulk import.

Definition at line 2277 of file bm.h.

Referenced by bm::bvector< Alloc >::bulk_insert_iterator::flush(), and bm::bvector<>::set().

## ◆ test()

template<class Alloc >

bool bm::bvector< Alloc >::test | ( | size_type | n | ) | const
| inline

returns true if bit n is set and false is bit n is 0.

Parameters

  n | - Index of the bit to check.

Returns
  Bit value (1 or 0)

Definition at line 1440 of file bm.h.

Referenced by bm::bvector<>::any_range(), bm::bvector<>::count_range(), bm::bvector<>::erase(), bm::bvector<>::is_all_one_range(), load_snp_report(), main(), pick_benchmark_set(), and bm::bvector<>::shift_left().

## ◆ throw_bad_alloc()

template<class Alloc >

void bm::bvector< Alloc >::throw_bad_alloc
| static

Definition at line 6730 of file bm.h.

## Friends And Related Function Documentation

## ◆ aggregator

template<class Alloc >
template<class BV >

friend class aggregator
| friend

Definition at line 810 of file bm.h.

## ◆ enumerator

template<class Alloc >

friend class enumerator
| friend

Definition at line 809 of file bm.h.

Referenced by bm::bvector<>::end(), and bm::bvector<>::get_enumerator().

## ◆ iterator_base

template<class Alloc >

friend class iterator_base
| friend

Definition at line 808 of file bm.h.

## ◆ operation_deserializer

template<class Alloc >
template<class BV >

friend class operation_deserializer
| friend

Definition at line 811 of file bm.h.

The documentation for this class was generated from the following file:

- bm.h